﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveCombine : WaveDisplay {

	private bool animating = false;

	public void Animate(){
		if (!animating) {
			StartCoroutine ("Animation");
		}
	}

	//Animation
	public IEnumerator Animation(){
		animating = true;
		yield return StartCoroutine(CombineWaves (1f, WaveGenerator.GetWave (WaveGenerator.yValMaster, m_bounds), WaveGenerator.GetWave (WaveGenerator.yValPuzzle, m_bounds)));
		yield return new WaitForSeconds (2f);
		animating = false;
	}

	//Wave Combination Animation
	IEnumerator CombineWaves(float time, Vector2[] wave1, Vector2[] wave2){
		float tStep = 1/time;
		float xStep = m_bounds.x/wave1.Length;
		float percentage = 0;
		while(percentage < 1){
			percentage += tStep * Time.deltaTime;
			int indexOffset = wave1.Length - (int)(wave1.Length * percentage);
			int combinedSize = wave2.Length + indexOffset;
			Vector2[] combinedWave = new Vector2[combinedSize];
			for (int i = 0; i < combinedSize; i++){
				if (i < indexOffset) {combinedWave[i] = wave2[i];}
				else if (i>=indexOffset && i<wave2.Length) {combinedWave[i] = wave2[i] + wave1[i-indexOffset];}
				else {combinedWave[i] =wave1[i-indexOffset];}

				combinedWave[i].x = (xStep * i) - (xStep * combinedSize * 0.5f);
			}
			DrawWaveFromPoints (combinedWave);
			yield return null;
		}
	}
}
