﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class FadePanel : MonoBehaviour {

	bool loadingScene = false;
	public AudioSource music;
	public Image fadePanel;

	void Start () {
			StartCoroutine (FadeIn (5f));
	}

	IEnumerator FadeIn(float fadeTime = 0){
		float fadeTimeTotal = fadeTime;
		while (fadeTime > 0) {
			fadeTime -= Time.deltaTime;
			fadePanel.color = Color.Lerp (fadePanel.color, new Color(1,1,1,0), 1 -(fadeTime/fadeTimeTotal));
			music.volume = Mathf.Lerp (music.volume, .8f, 1-(fadeTime / fadeTimeTotal));
			yield return null;
		}
		fadePanel.color = new Color(1,1,1,0);
		music.volume = .8f;
	}

	public void LoadEnd(){
		if (!loadingScene){
			StartCoroutine (LoadEndScene (5f));
		}
	}

	IEnumerator LoadEndScene(float fadeTime = 0){
		float fadeTimeTotal = fadeTime;
		loadingScene = true;
		while (fadeTime > 0) {
			fadeTime -= Time.deltaTime;
			fadePanel.color = Color.Lerp (fadePanel.color, Color.white, 1 -(fadeTime/fadeTimeTotal));
			music.volume = Mathf.Lerp (music.volume, 0, 1-(fadeTime / fadeTimeTotal));
			yield return null;
		}
		SceneManager.LoadScene ("endScene"); 
	}

	void Update(){
		if (Input.GetKeyDown (KeyCode.Escape))
			SceneManager.LoadScene ("titleScene"); 
	}
}
