﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class MainMenu : MonoBehaviour {

	bool loadingScene = false;
	public AudioSource music;
	public Image fadePanel;

	public void PlayButton(){
		if (!loadingScene){
			StartCoroutine (LoadGameScene (5f));
		}
	}

	IEnumerator LoadGameScene(float fadeTime = 0){
		float fadeTimeTotal = fadeTime;
		loadingScene = true;
		while (fadeTime > 0) {
			fadeTime -= Time.deltaTime;
			fadePanel.color = Color.Lerp (fadePanel.color, Color.white, 1 -(fadeTime/fadeTimeTotal));
			music.volume = Mathf.Lerp (music.volume, 0, 1-(fadeTime / fadeTimeTotal));
			yield return null;
		}
		SceneManager.LoadScene ("main"); 
	}

	public void Quit(){
		Application.Quit ();
		Debug.Log ("Quit!");
	}
}
