﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveDisplay : MonoBehaviour {

	protected LineRenderer m_lineRenderer;
	protected BoxCollider2D m_boundingBox;
	protected Vector2 m_bounds {
		get {
			if (m_boundingBox == null)
				return Vector2.one;
			else
				return m_boundingBox.size;
		}
	}

	protected virtual void Awake () {
		m_lineRenderer = gameObject.GetComponent<LineRenderer> ();
		m_boundingBox = gameObject.GetComponent<BoxCollider2D> ();
	}

	public virtual void DrawWave (WaveGenerator.yValMethod yVal, int resolution = 150){
		DrawWaveFromPoints (WaveGenerator.GetWave (yVal, m_bounds, resolution)); 
	}

	protected void DrawWaveFromPoints(Vector2[] wavePoints){
		if (wavePoints.Length == 0)
			return;
		m_lineRenderer.numPositions = wavePoints.Length;
		for (int i = 0; i < wavePoints.Length; i++) {
			m_lineRenderer.SetPosition (i, new Vector3(wavePoints[i].x, wavePoints[i].y,0));
		}
	}
}
