﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveGenerator {

	public delegate float yValMethod(float percentage); //This is a container for sine waves, pretty much

	public static Vector2[] GetWave(yValMethod yVal, Vector2 bounds, int resolution = 1500){
		//resolution = (int)(Mathf.Clamp(resolution * m_frequencyCorrected, resolution, resolution *10));//Scale resoluton with frequency
		Vector2[] wave = new Vector2[resolution];

		float xStep = bounds.x / resolution;
		float yStep = Mathf.PI / resolution;
		Vector2 halfBounds = bounds / 2f;

		for (int i = 0; i < resolution; i++) {
			float x = i * xStep - halfBounds.x;
			float y = yVal ((i * yStep * bounds.x) - (Mathf.PI * halfBounds.x)) * halfBounds.y;
			wave [i] = new Vector2 (x, y);
		}

		return wave;
	}

	//Lots of SINE WAVES past this point. You have been warned.
	//private static float m_amplitudeTargetCorrected { get { return Mathf.Pow (2, Controller._.amplitudeTarget); } }
	//public static float m_frequencyTargetCorrected { get { return Mathf.Pow (10, Controller._.frequencyTarget); } }
	//private static float m_phaseTargetCorrected { get { return (Controller._.phaseTarget * Mathf.PI); } }

	public static float yValPuzzle(float t){
		float hex = CreateWaveForms.squareWave (t, Controller._.hexTarget.x, Controller._.hexTarget.y) * Mathf.Abs (Controller._.hexTarget.y);
		float circ = CreateWaveForms.sineWave (t, Controller._.circTarget.x, Controller._.circTarget.y) * Mathf.Abs (Controller._.circTarget.y);
		float tri = CreateWaveForms.triangleWave (t, Controller._.triTarget.x, Controller._.triTarget.y) * Mathf.Abs (Controller._.triTarget.y);
		return (hex + circ + tri) * -1f / Mathf.Clamp (Mathf.Abs (Controller._.hexTarget.y) + Mathf.Abs (Controller._.circTarget.y) + Mathf.Abs (Controller._.triTarget.y), 1, float.MaxValue);
		}

	//private static float m_amplitudeCorrected { get { return Mathf.Pow (2, Controller._.amplitude); } }
	//private static float m_frequencyCorrected { get { return Mathf.Pow (10, Controller._.frequency); } }
	//private static float m_phaseCorrected { get { return (Controller._.phase * Mathf.PI); } }

	//public static float yValMasterColors(float t){ return (m_amplitudeCorrected * (yValFrequency (t) + yValPhase (t)) * 0.5f); }
	//public static float yValAmplitude(float t){ return (Mathf.Sin (t) * m_amplitudeCorrected); }
	//public static float yValFrequency(float t){ return (Mathf.Sin (t * m_frequencyCorrected)); }
	//public static float yValPhase(float t){ return (Mathf.Sin (t+ m_phaseCorrected)); }


	//New Waves:
	public static float yValMaster(float t){return (yValHex (t)*Mathf.Abs (Controller._.hex.y) + yValCirc (t)*Mathf.Abs (Controller._.circ.y) + yValTri (t)*Mathf.Abs (Controller._.tri.y)) / Mathf.Clamp(Mathf.Abs (Controller._.hex.y) + Mathf.Abs (Controller._.circ.y) + Mathf.Abs (Controller._.tri.y),1,float.MaxValue);}
	public static float yValHex(float t){ return CreateWaveForms.squareWave (t, Controller._.hex.x, Controller._.hex.y);}
	public static float yValCirc(float t){return CreateWaveForms.sineWave (t, Controller._.circ.x, Controller._.circ.y);}
	public static float yValTri(float t){return CreateWaveForms.triangleWave (t, Controller._.tri.x, Controller._.tri.y);}


	//Test Methods:
	public static Vector2[] TestWave(Vector2 bounds){ return GetWave (TestPoint, bounds); }
	static float TestPoint (float percentage){ return (Mathf.Sin (percentage)); }
}
